<?php
	define('IN_APP', true);
	require_once dirname(__FILE__) . '/lib/inc.config.php';
	require_once dirname(__FILE__) . '/lib/class.user.php';
	
	if(isset($_CONFIG['db'])) {
		if(	isset($_SERVER['PHP_AUTH_USER']) && preg_match($_REGEX['user_name']['regex'], $_SERVER['PHP_AUTH_USER']) && 
			isset($_SERVER['PHP_AUTH_PW']) && preg_match($_REGEX['user_password']['regex'], $_SERVER['PHP_AUTH_PW'])
			) {
			if($_CONFIG['db']->isValidAdminLogin($_SERVER['PHP_AUTH_USER'], md5($_SERVER['PHP_AUTH_PW']))) {
				// valid admin
				$_CONFIG['smarty']->assign('hint', "");
				if(isset($_GET["action"]) && preg_match('/^((save|delete)(Webcam|User|Category)|move)$/', $_GET["action"])) {
					switch($_GET["action"]) {
						// --- webcam
						case "saveWebcam":
							
							if(	preg_match($_REGEX['webcam_type']['regex'], $_POST["webcam_type"]) &&
								preg_match($_REGEX['webcam_title']['regex'], $_POST["webcam_title"]) &&
								preg_match($_REGEX['webcam_url']['regex'], $_POST["webcam_url"]) &&
								preg_match($_REGEX['webcam_woeid']['regex'], $_POST["webcam_woeid"]) //&&
								//preg_match($_REGEX['id']['regex'], $_POST["webcam_categories"]) // not working while multi array
								) {
								if(is_array($_POST['webcam_categories'])) {
									// check cat array id's against regex
									$l_validCategoryArray = true;
									foreach ($_POST['webcam_categories'] as $l_Key => $l_CategoryID) {
										if(!preg_match($_REGEX['id']['regex'], $l_CategoryID)) {
											$l_validCategoryArray = false; // regex error
										}
									}
									if($l_validCategoryArray) {
										// save webcam
										$_CONFIG['db']->saveWebcam($_POST["webcam_type"], $_POST["webcam_url"], $_POST["webcam_title"], $_POST['webcam_categories'], $_POST['webcam_woeid']);
										$_CONFIG['smarty']->assign('hint', "webcam saved");	
									} else {
										$_CONFIG['smarty']->assign('hint', "webcam not saved (category id regex mismatch)");
									}
								} else {
									// no cat, show error, no save
									$_CONFIG['smarty']->assign('hint', "webcam not saved (no category)");
								}

							} else {
								$_CONFIG['smarty']->assign('hint', "regex mismatch");
							}
							$_CONFIG['smarty']->assign('BottomScript', "toggleContainer('webcam_container', '" . $_CONFIG['template'] . "');");	
						break;
		
						case "deleteWebcam":
							if(preg_match($_REGEX['id']['regex'], $_GET["id"])) {
								$_CONFIG['db']->deleteWebcam($_GET["id"]);
								$_CONFIG['smarty']->assign('hint', "webcam deleted");
							} else {
								$_CONFIG['smarty']->assign('hint', "regex mismatch");
							}
							$_CONFIG['smarty']->assign('BottomScript', "toggleContainer('webcam_container', '" . $_CONFIG['template'] . "');");					
						break;
				
						// --- user
						case "saveUser":
							if(	preg_match($_REGEX['user_name']['regex'], $_POST["user_name"]) &&
								preg_match($_REGEX['user_password']['regex'], $_POST["user_password"]) &&
								preg_match($_REGEX['user_admin']['regex'], $_POST["user_admin"])
								) {
								$_CONFIG['db']->saveUser($_POST["user_name"], md5($_POST["user_password"]), $_POST["user_admin"]);
								$_CONFIG['smarty']->assign('hint', "user saved");
							} else {
								$_CONFIG['smarty']->assign('hint', "regex mismatch");
							}
							$_CONFIG['smarty']->assign('BottomScript', "toggleContainer('user_container', '" . $_CONFIG['template'] . "');");
						break;
		
						case "deleteUser":
							if(preg_match($_REGEX['id']['regex'], $_GET["id"])) {
								$_CONFIG['db']->deleteUser($_GET["id"]);
								$_CONFIG['smarty']->assign('hint', "user deleted");
							} else {
								$_CONFIG['smarty']->assign('hint', "regex mismatch");
							}
							$_CONFIG['smarty']->assign('BottomScript', "toggleContainer('user_container', '" . $_CONFIG['template'] . "');");
						break;
		
						// --- category
						case "saveCategory":
							if(	preg_match($_REGEX['category_name']['regex'], $_POST["category_name"])){
								$_CONFIG['db']->saveCategory($_POST["category_name"]);
								$_CONFIG['smarty']->assign('hint', "category saved");
							} else {
								$_CONFIG['smarty']->assign('hint', "regex mismatch");
							}
							$_CONFIG['smarty']->assign('BottomScript', "toggleContainer('category_container', '" . $_CONFIG['template'] . "');");
						break;
		
						case "deleteCategory":
							if(preg_match($_REGEX['id']['regex'], $_GET["id"])) {
								$_CONFIG['db']->deleteCategory($_GET["id"]);
								$_CONFIG['smarty']->assign('hint', "category deleted");
							} else {
								$_CONFIG['smarty']->assign('hint', "regex mismatch");
							}
							$_CONFIG['smarty']->assign('BottomScript', "toggleContainer('category_container', '" . $_CONFIG['template'] . "');");
						break;					
		
						// --- other
						case "move":
						break;
		
						default:
							$_CONFIG['smarty']->assign('hint', "no valid action");
						break;
					}
				}
				$_CONFIG['smarty']->assign('RegExList', $_REGEX);
				$_CONFIG['smarty']->assign('configs', $_CONFIG['db']->loadConfig());
				$_CONFIG['smarty']->assign('categories', $_CONFIG['db']->loadCategories());
				$_CONFIG['smarty']->assign('users', $_CONFIG['db']->loadUsers());
				$_CONFIG['smarty']->assign('webcams', $_CONFIG['db']->loadWebcams());

				$l_UpdateResult = "";
				preg_match('/Released Version ([0-9A-Za-z.-]+):/', fetchURLContent('http://wiki.laub-home.de/index.php/LookOut_-_Webcam_Overview_Tool'), $l_UpdateResult);
				if ($l_UpdateResult[1] != $_CONFIG['version']) {
					$_CONFIG['smarty']->assign('hint', "lookout update available: <b>v" . $l_UpdateResult[1] . " | installed: v" . $_CONFIG['version'] . " </b>");
				}
				
				$_CONFIG['smarty']->display('template.admin.tpl');				
			} else {
				$_CONFIG['smarty']->assign('info_title', "d'oh! admin only!");
				$_CONFIG['smarty']->assign('info_message', "Hm, access without to be admin? No way!");
				$_CONFIG['smarty']->display('template.info_message.tpl');	
			}
		} else {
	    	header('WWW-Authenticate: Basic realm="lookout"');
	    	header('HTTP/1.0 401 Unauthorized');
			$_CONFIG['smarty']->assign('info_title', "d'oh! admin only!");
			$_CONFIG['smarty']->assign('info_message', "No valid Admin login.");
			$_CONFIG['smarty']->display('template.info_message.tpl');
	    	exit;
		}
	} else {
		header ("HTTP/1.1 302 Found");
  		header ("Location: ./wizard.php"); 
	}
			
?>