<?php
	define('IN_APP', true);
	require_once dirname(__FILE__) . '/lib/inc.config.php';	
	require_once dirname(__FILE__) . '/lib/common/FeedWriter/FeedWriter.php';
	require_once dirname(__FILE__) . '/lib/common/FeedWriter/FeedItem.php';

	function guessUrl() {
		if(is_ssl()) {
			$l_protocol = 'https://';
		} else {
			$l_protocol = 'http://';
		}
		return $l_protocol . $_SERVER['HTTP_HOST'] . str_replace("/api.php", "", $_SERVER['SCRIPT_NAME']);
	}
	
	function is_ssl() {
		if ( isset($_SERVER['HTTPS']) ) {
			if ( 'on' == strtolower($_SERVER['HTTPS']) )
				return true;
			if ( '1' == $_SERVER['HTTPS'] )
				return true;
		} elseif ( isset($_SERVER['SERVER_PORT']) && ( '443' == $_SERVER['SERVER_PORT'] ) ) {
			return true;
		}
		return false;
	}		
	
	if(isset($_GET["type"]) && preg_match('/^(atom|json|xml)$/', $_GET["type"])) {
		$l_Webcams = $_CONFIG['db']->loadWebcams();
		switch($_GET["type"]) {
			case "xml":
				header("Content-Type: text/xml; charset=UTF-8");
				$l_XmlDoc = new DOMDocument("1.0");
				$l_RootElement = $l_XmlDoc->createElement("lookout");
				$l_XmlDoc->appendChild($l_RootElement);
				foreach($l_Webcams as $l_Webcam) {
					$l_WebcamElement = $l_XmlDoc->createElement("webcam");
					$l_WebcamTitle = $l_XmlDoc->createElement("title");
					$l_WebcamTitle->appendChild($l_XmlDoc->createTextNode(utf8_encode($l_Webcam->getTitle())));
					$l_WebcamURL = $l_XmlDoc->createElement("url");
					if($_CONFIG['webcam_mode'] == 'fetch') {
						$l_WebcamURL->appendChild($l_XmlDoc->createTextNode(utf8_encode(guessUrl() . '/webcamfetcher.php?webcam=' . $l_Webcam->getId())));	
					} else {
						$l_WebcamURL->appendChild($l_XmlDoc->createTextNode(utf8_encode($l_Webcam->getURL())));	
					}
					$l_WebcamElement->appendChild($l_WebcamTitle);
					$l_WebcamElement->appendChild($l_WebcamURL);
					$l_RootElement->appendChild($l_WebcamElement);
				}
				echo $l_XmlDoc->saveXML();				
			break;
			
			case "json":
				$l_DataArray = array();
				foreach ($l_Webcams as $l_Webcam) {
					$l_Url = "";
					if($_CONFIG['webcam_mode'] == 'fetch') {
						$l_Url = utf8_encode(guessUrl() . '/webcamfetcher.php?webcam=' . $l_Webcam->getId());	
					} else {
						$l_Url = utf8_encode($l_Webcam->getURL());	
					}
					$l_DataArray[] = array('title' => utf8_decode($l_Webcam->getTitle()),
											'url'  => $l_Url
											);
				}
				echo json_encode($l_DataArray);
			break;
			
			case "atom":
				$l_Feed = new FeedWriter(ATOM);
				$l_Feed->setTitle('lookout webcam feed');
				$l_Feed->setLink(guessUrl() . '/api.php?type=atom');
				$l_Feed->setChannelElement('logo', 'http://www.bunker13.de/projects/lookout/src/templates/default/img/lookout_logo_small.png');
				$l_Feed->setChannelElement('icon', 'http://www.bunker13.de/projects/lookout/src/templates/default/favicon.ico');
				$l_Feed->setChannelElement('updated', date(DATE_ATOM , time()));
				$l_Feed->setChannelElement('author', array('name'=>'lookout'));
				// add feeds
				foreach ($l_Webcams as $l_Webcam) {
					$l_Item = $l_Feed->createNewItem();
					$l_Item->setTitle(utf8_decode($l_Webcam->getTitle()));
					if($_CONFIG['webcam_mode'] == 'fetch') {
						$l_Item->setLink(utf8_encode(guessUrl() . '/webcamfetcher.php?webcam=' . $l_Webcam->getId()));	
					} else {
						$l_Item->setLink(utf8_decode($l_Webcam->getUrl()));
					}					
					$l_Item->setDate(date(DATE_ATOM , time()));
					$l_Item->setDescription(utf8_decode($l_Webcam->getTitle()));
					$l_Feed->addItem($l_Item);				
				}
				// --
				$l_Feed->genarateFeed();
			break;
			
			default:
				echo "unknown<br>";
			break;
		}
	} else {
		echo "missing type<br>";
	}
?>