<?php

	/**
	 * Selfdefined DB exception
	 * @author mwendel
	 * @version 1.0
	 * @package SIL
	 */
	class DBException extends Exception {
		/**
		 * DBException constant for a unknown exception
		 * @var const int
		 */
		const UNKNOWN = -1;		

		/**
		 * DBException constant for a missing options exception
		 * @var const int
		 */
		const OPTIONS = 0;
		
		/**
		 * DBException constant for a connection exception
		 * @var const int
		 */
		const CONNECT = 1;

		/**
		 * DBException constant for a select db exception
		 * @var const int
		 */
		const DB = 2;

		/**
		 * DBException constant for a query exception
		 * @var const int
		 */
		const QUERY = 3;			
		
		/**
		 * Constructor for user defined message type and optional text element
		 * @param const $p_Type Type of DBException defined with self::constants
		 * @param string $p_Text Optional text element for message
		 */
		public function __construct($p_Type = 0, $p_Text = "") {
			switch ($p_Type) {
            	case self::OPTIONS:
					parent::__construct("DBException: Missing options during connect", 30);           		
            	break;

            	case self::CONNECT:
					parent::__construct("DBException: DB connection failed", 31);           		
            	break;

            	case self::DB:
					parent::__construct("DBException: DB selection failed", 32);           		
            	break;               	
 
            	case self::QUERY:
					parent::__construct("DBException: Query Exception", 33);           		
            	break;               	

            	case self::UNKNOWN:
            	default:
            		parent::__construct("DBException: Unknown Exception", 99);
            	break;
			}
		}
	}
?>