<?php

	class DBMysql extends DBAbstract {
		
		public function __construct(array $p_ConnectOptions, $p_EscapeData = true) {
			if(count($p_ConnectOptions) == 5) {
				$this->m_TablePrefix = $p_ConnectOptions['table_prefix'];
				$this->m_EscapeData = $p_EscapeData;
				$this->m_DbRessource = mysql_pconnect(
														$p_ConnectOptions['server'],
														$p_ConnectOptions['user'],
														$p_ConnectOptions['password']
													 );
				if(!$this->m_DbRessource) {
					throw new DBException(DBException::CONNECT);
				} elseif(!mysql_select_db($p_ConnectOptions['db'], $this->m_DbRessource)) {
					throw new DBException(DBException::DB);
				}
			} else {
				throw new DBException(DBException::OPTIONS);
			}
		}

		// --------------------------------------------------------------------------------------
		
		
		// --- webcam related functions
		public function saveWebcam($p_Type, $p_Url, $p_Title, $p_Categories, $p_WOEID) {
			// save webcam
			$l_SqlQuery = "INSERT INTO `" . $this->escapeData($this->m_TablePrefix) . "webcam`"
								. "(`type`, `datetime`, `url`, `title`, `owner_id`, `woeid`) "
								. "VALUES('" . $this->escapeData($p_Type) . "', NOW(), '" . $this->escapeData($p_Url) . "', "
								. "'" . $this->escapeData($p_Title) . "', 1, '" . $this->escapeData($p_WOEID) . "');";
			$l_Res = mysql_query($l_SqlQuery, $this->m_DbRessource);
				if(!$l_Res) { throw new DBException(DBException::QUERY); }
			
			// get id from newly saved webcam
			$l_SqlQuery = "SELECT `webcam_id` FROM `" . $this->escapeData($this->m_TablePrefix) . "webcam` "
						. "WHERE `url` = '" . $this->escapeData($p_Url) . "' LIMIT 0 , 1;";
			$l_SqlResultSet = mysql_query($l_SqlQuery, $this->m_DbRessource);
								if(!$l_SqlResultSet) { throw new DBException(DBException::QUERY); }		
			// num rows == 1 ?				
			$l_SqlDataArray = mysql_fetch_assoc($l_SqlResultSet);
			$l_WebcamID = $l_SqlDataArray['webcam_id'];

			// save webcam categories references
			foreach ($p_Categories as $l_Key => $l_CategoryID) {
				$l_SqlQuery = "INSERT INTO `" . $this->escapeData($this->m_TablePrefix) . "relation_webcam_category` "
								. "(`webcam_id`, `category_id`) "
								. "VALUES('" . $this->escapeData($l_WebcamID) . "', '" . $this->escapeData($l_CategoryID) . "');";
				$l_Res = mysql_query($l_SqlQuery, $this->m_DbRessource);
					if(!$l_Res) { throw new DBException(DBException::QUERY); }
			}			
		}
		
		public function deleteWebcam($p_ID) {
			$l_SqlQuery = "DELETE FROM `" . $this->escapeData($this->m_TablePrefix) . "relation_webcam_category` WHERE `webcam_id` = ". $this->escapeData($p_ID);
			mysql_query($l_SqlQuery, $this->m_DbRessource) or die(mysql_error());
// innodb cascade ?						
			$l_SqlQuery = "DELETE FROM `" . $this->escapeData($this->m_TablePrefix) . "webcam` WHERE `webcam_id` = ". $this->escapeData($p_ID);
			mysql_query($l_SqlQuery, $this->m_DbRessource) or die(mysql_error());
			// multi query ?	
		}		
		
		public function loadWebcams() {
			$l_SqlQuery = "SELECT `webcam_id`, `type`, `url`, `title`, `datetime`, `woeid` FROM `" . $this->escapeData($this->m_TablePrefix) . "webcam` "
						. "ORDER BY `webcam_id` ASC;";
			$l_SqlResultSet = mysql_query($l_SqlQuery, $this->m_DbRessource) or die(mysql_error());
			$l_ReturnArray = array();
			while ($l_ResultRow = mysql_fetch_assoc($l_SqlResultSet)) {
				$l_ReturnArray[] = new Webcam($l_ResultRow['webcam_id'], $l_ResultRow['type'], $l_ResultRow['url'],
												$l_ResultRow['title'], $l_ResultRow['datetime'], $l_ResultRow['woeid']); 
			}
			return $l_ReturnArray;
		}

		public function loadWebcam($p_WebcamID) {
			$l_SqlQuery = "SELECT `webcam_id`, `type`, `url`, `title`, `datetime`, `woeid` FROM `" . $this->escapeData($this->m_TablePrefix) . "webcam` "
						. "WHERE `webcam_id` = " . $this->escapeData($p_WebcamID);
			$l_SqlResultSet = mysql_query($l_SqlQuery, $this->m_DbRessource) or die(mysql_error());
			$l_SqlDataArray = mysql_fetch_assoc($l_SqlResultSet);
			// is valid webcam? is ==1 ?
			$l_Webcam = new Webcam($l_SqlDataArray['webcam_id'], $l_SqlDataArray['type'], $l_SqlDataArray['url'],
									$l_SqlDataArray['title'], $l_SqlDataArray['datetime'], $l_SqlDataArray['woeid']);
			return $l_Webcam;
		}		
		
		public function loadWebcamsByCategory($p_CategoryID) {
			$l_SqlQuery = "SELECT `webcam_id` FROM `" . $this->escapeData($this->m_TablePrefix) . "relation_webcam_category` "
						. "WHERE `category_id` =  ". $this->escapeData($p_CategoryID) . " ORDER BY `webcam_id` ASC;";
						$l_SqlResultSet = mysql_query($l_SqlQuery, $this->m_DbRessource) or die(mysql_error());
			$l_ReturnArray = array();
			while ($l_ResultRow = mysql_fetch_assoc($l_SqlResultSet)) {
				$l_ReturnArray[] = $this->loadWebcam($l_ResultRow['webcam_id']);
			}
			return $l_ReturnArray;									
		}
		
		// --------------------------------------------------------------------------------------	

		// --- user related functions
		public function isValidAdminLogin($p_Name, $p_Password) {
			$l_SqlQuery = "SELECT `user_id` FROM `" . $this->escapeData($this->m_TablePrefix) . "user` "
						. "WHERE `name` = '" . $this->escapeData($p_Name) . "' "
						. "AND `password` = '" . $this->escapeData($p_Password) . "' "
						. "AND `admin` = 1;";
			$l_SqlResultSet = mysql_query($l_SqlQuery, $this->m_DbRessource) or die(mysql_error());
			return mysql_num_rows($l_SqlResultSet);
		}
		
		public function saveUser($p_Name, $p_Password, $p_Admin) {
			$l_SqlQuery = "INSERT INTO `" . $this->escapeData($this->m_TablePrefix) . "user`"
								. "(`name`, `datetime`, `password`, `admin`) "
								. "VALUES('" . $this->escapeData($p_Name) . "', NOW(), '" . $this->escapeData($p_Password) . "', "
								. "'" . $this->escapeData($p_Admin) . "');";
			mysql_query($l_SqlQuery, $this->m_DbRessource) or die(mysql_error());
		}
		
		public function deleteUser($p_ID) {
			$l_SqlQuery = "DELETE FROM `" . $this->escapeData($this->m_TablePrefix) . "user` WHERE `user_id` = ". $this->escapeData($p_ID);
			mysql_query($l_SqlQuery, $this->m_DbRessource) or die(mysql_error());
		}
		
		public function loadUsers() {
			$l_SqlQuery = "SELECT `user_id`, `name`, `datetime`, `admin` FROM `" . $this->escapeData($this->m_TablePrefix) . "user` "
						. "ORDER BY `user_id` ASC;";
			$l_SqlResultSet = mysql_query($l_SqlQuery, $this->m_DbRessource) or die(mysql_error());
			$l_ReturnArray = array();
			while ($l_ResultRow = mysql_fetch_assoc($l_SqlResultSet)) {
				$l_ReturnArray[] = new User($l_ResultRow['user_id'], $l_ResultRow['name'], $l_ResultRow['datetime'], $l_ResultRow['admin']); 
			}
			return $l_ReturnArray;			
		}
		// --------------------------------------------------------------------------------------		
		
		// --- category related functions
		public function saveCategory($p_Name) {
			// owner id placeholder, not working/get from session user info
			$l_SqlQuery = "INSERT INTO `" . $this->escapeData($this->m_TablePrefix) . "category`"
								. "(`name`, `datetime`, `owner_id`) "
								. "VALUES('" . $this->escapeData($p_Name) . "', NOW(), 1);";
			mysql_query($l_SqlQuery, $this->m_DbRessource) or die(mysql_error());			
		}
		
		public function deleteCategory($p_ID) {
			$l_SqlQuery = "DELETE FROM `" . $this->escapeData($this->m_TablePrefix) . "relation_webcam_category` WHERE `category_id` = ". $this->escapeData($p_ID);
			mysql_query($l_SqlQuery, $this->m_DbRessource) or die(mysql_error());
// innodb cascade ?			
			$l_SqlQuery = "DELETE FROM `" . $this->escapeData($this->m_TablePrefix) . "category` WHERE `category_id` = ". $this->escapeData($p_ID);
			mysql_query($l_SqlQuery, $this->m_DbRessource) or die(mysql_error());
			// multi query ?
		}
		
		public function loadCategories() {
			$l_SqlQuery = "SELECT `category_id`, `name`, `datetime`, `owner_id` FROM `" . $this->escapeData($this->m_TablePrefix) . "category` "
						. "ORDER BY `category_id` ASC;";
			$l_SqlResultSet = mysql_query($l_SqlQuery, $this->m_DbRessource) or die(mysql_error());
			$l_ReturnArray = array();
			while ($l_ResultRow = mysql_fetch_assoc($l_SqlResultSet)) {
				$l_ReturnArray[] = new Category($l_ResultRow['category_id'], $l_ResultRow['name'], $l_ResultRow['datetime'], $l_ResultRow['owner_id']); 
			}
			return $l_ReturnArray;				
		}
		// --------------------------------------------------------------------------------------	
		
		// --- config related functions
		public function loadConfig() {
			$l_ReturnArray = array();
			$l_SqlQuery = "SELECT `name`, `value` FROM `" . $this->escapeData($this->m_TablePrefix) . "config` ORDER BY `config_id` ASC;";
			$l_SqlResultSet = mysql_query($l_SqlQuery, $this->m_DbRessource) or die(mysql_error());
			while ($l_ResultRow = mysql_fetch_assoc($l_SqlResultSet)) {
				$l_ReturnArray[] = array("name" => $l_ResultRow['name'], "value" => $l_ResultRow['value']); 
			}
			return $l_ReturnArray;
		}
		// --------------------------------------------------------------------------------------		
	
	}
?>